/**********************************************************************/
/***                                                                ***/
/***  vorrueckwaertsubs.h                                           ***/
/***                                                                ***/
/***  Vorwaerts und Rueckwaertssubstitution                         ***/
/***                                                                ***/
/**********************************************************************/
/***                                                                ***/
/***  Autorin: Luise Blank                                          ***/
/***                                                                ***/
/***  Datum: 2.11.2011                                              ***/
/***                                                                ***/
/**********************************************************************/

/*
 vwsubs                                                   
   Diese Funktion loest das Gleichungssystem Lx=b, 
   wobei L eine normierte untere Dreiecksmatrix ist mittels 
   Vorwaertssubstitution. Dabei wird die rechte Seite b mit 
   der Loesung ueberschrieben.         
  input:  int           n        Dimension der Matrix 
          double**      L        Zeiger auf normierte untere Dreiecksmatrix
          double*       b        Rechte Seite und Ausgabe 
  output: void  
*/
void vwsubs(int n, double ** L, double * b);


/*
  rwsubs
    Diese Funktion loest das Gleichungssystem Rx=b, 
    wobei R eine regulaere obere Dreiecksmatrix ist mittels
    Rueckwaertssubstitution. Dabei wird die rechte Seite b 
    mit der Loesung ueberschrieben. 
   input:  int           n        Dimension der Matrix 
           double**      R        Zeiger auf obere Dreiecksmatrix
           double*       b        Rechte Seite und Ausgabe  
   output: void 
*/
void rwsubs(int n, double ** R, double * b);
